#!/usr/bin/env node
"use strict";var _process=require("process");

var _updateNotifier=_interopRequireDefault(require("update-notifier"));
var _readPkgUp=_interopRequireDefault(require("read-pkg-up"));

var _top=require("./top.js");
var _parse=require("./parse.js");
var _single=require("./single.js");
var _serial=require("./serial.js");
var _parallel=require("./parallel.js");
var _fault=require("./fault.js");function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}


const runCli=async function(){
try{
await checkUpdate();

const yargs=(0,_top.defineCli)();
const{
versionRanges,
command,
args,
opts,
continueOpt,
parallel}=
(0,_parse.parseInput)(yargs);
const exitCode=await runMain({
versionRanges,
command,
args,
opts,
continueOpt,
parallel});

(0,_process.exit)(exitCode);
}catch(error){
(0,_fault.handleFault)(error);
(0,_process.exit)(1);
}
};

const checkUpdate=async function(){
const{packageJson}=await(0,_readPkgUp.default)({cwd:__dirname,normalize:false});
(0,_updateNotifier.default)({pkg:packageJson}).notify();
};

const runMain=function({
versionRanges,
command,
args,
opts,
continueOpt,
parallel})
{
if(versionRanges.length===1){
return(0,_single.runSingle)({versionRanges,command,args,opts});
}

if(parallel){
return(0,_parallel.runParallel)({versionRanges,command,args,opts,continueOpt});
}

return(0,_serial.runSerial)({versionRanges,command,args,opts,continueOpt});
};

runCli();
//# sourceMappingURL=bin.js.map