"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.handleParallelError=exports.handleSerialError=exports.handleSingleError=void 0;var _process=require("process");
var _util=require("util");

var _chalk=require("chalk");

var _fault=require("./fault.js");
var _output=require("./output.js");
var _header=require("./header.js");

const pSetTimeout=(0,_util.promisify)(setTimeout);















const handleSingleError=function({
originalMessage,
exitCode=DEFAULT_EXIT_CODE,
...error})
{
if(originalMessage!==undefined){
_process.stderr.write(`${originalMessage}\n`);
}

(0,_fault.printInvalidCommand)({...error,exitCode});

return exitCode;
};exports.handleSingleError=handleSingleError;


const handleSerialError=function(error,versionRange,state){
handleMultipleError(error,versionRange,state);
};exports.handleSerialError=handleSerialError;




const handleParallelError=async function({
error,
versionRange,
continueOpt,
state,
index})
{
if(continueOpt){
handleAnyParallelError({error,versionRange,state,index});
return;
}


await pSetTimeout(0);

handleFastParallelError({error,versionRange,state,index});
};exports.handleParallelError=handleParallelError;


const handleFastParallelError=function({
error,
versionRange,
state,
index})
{
printAborted({error,versionRange,state,index});
handleAnyParallelError({
error:state.failedError,
versionRange:state.failedVersionRange,
state,
index:state.failedIndex});

};




const printAborted=function({
error,
versionRange,
state:{failedError,failedVersionRange},
index})
{
if(failedError===error){
return;
}

(0,_output.writeProcessOutput)(error.all,_process.stdout,index);

_process.stderr.write((0,_chalk.red)(`Node ${versionRange} aborted\n`));

(0,_header.printVersionHeader)(failedVersionRange);
};


const handleAnyParallelError=function({error,versionRange,state,index}){
(0,_output.writeProcessOutput)(`${error.all}\n`,_process.stdout,index);
handleMultipleError(error,versionRange,state);
};








const handleMultipleError=function(
{shortMessage,exitCode=DEFAULT_EXIT_CODE,...error},
versionRange,
state)
{
const commandMessage=getCommandMessage(shortMessage,versionRange);
_process.stderr.write(`${commandMessage}\n`);

(0,_fault.printInvalidCommand)({...error,exitCode});


state.exitCode=exitCode;
};

const getCommandMessage=function(shortMessage,versionRange){
return(0,_chalk.red)(
shortMessage.
replace(COMMAND_REGEXP,"").
replace("Command",`Node ${versionRange}`));

};


const COMMAND_REGEXP=/:.*/u;

const DEFAULT_EXIT_CODE=1;
//# sourceMappingURL=error.js.map