"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.printInvalidCommand=exports.handleFault=void 0;var _process=require("process");

var _chalk=require("chalk");



const handleFault=function({message}){
_process.stderr.write(`${message}\n`);
printHelp(message);
};exports.handleFault=handleFault;


const printHelp=function(message){
if(!shouldPrintHelp(message)){
return;
}

_process.stderr.write(SHORT_USAGE);
};

const shouldPrintHelp=function(message){
return message.includes("Missing version");
};



const printInvalidCommand=function(error){
if(!isInvalidComment(error)){
return;
}

_process.stderr.write(SHORT_USAGE);
};exports.printInvalidCommand=printInvalidCommand;

const isInvalidComment=function({code,exitCode}){
return code==="ENOENT"||exitCode===BASH_COMMAND_CODE;
};



const BASH_COMMAND_CODE=127;

const SHORT_USAGE=`
${(0,_chalk.red)("Invalid input syntax.")}

It should be:

  nve [OPTIONS...] VERSION... [COMMAND] [ARGS...]

Examples:

  nve 8 node file.js
  nve 8 npm test
  nve 8 9 10 npm test
  nve --no-progress 8 npm test
`;
//# sourceMappingURL=fault.js.map