"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.parseInput=void 0;var _process=require("process");

var _semver=require("semver");

var _options=require("./options.js");


const parseInput=function(yargs){
const input=_process.argv.slice(2);

const{versionRanges,command,args,opts}=parseArgs(input);
const{opts:optsA,continueOpt,parallel}=(0,_options.parseOpts)(opts,yargs);


if(versionRanges.length===0){
throw new Error("Missing version.");
}

return{versionRanges,command,args,opts:optsA,continueOpt,parallel};
};exports.parseInput=parseInput;

const parseArgs=function(input){


const versionStart=getVersionStart(input);
const opts=input.slice(0,versionStart);
const otherArgs=input.slice(versionStart);


const versionEnd=getVersionEnd(otherArgs);
const versionRanges=otherArgs.slice(0,versionEnd);
const[command,...args]=otherArgs.slice(versionEnd);

return{versionRanges,command,args,opts};
};


const getVersionStart=function(input){
const versionStart=input.findIndex(isPositionalArg);

if(versionStart===-1){
return input.length;
}

return versionStart;
};

const isPositionalArg=function(arg){
return!arg.startsWith("-");
};


const getVersionEnd=function(otherArgs){
const versionEnd=otherArgs.findIndex(isCommand);

if(versionEnd===-1){
return otherArgs.length;
}

return versionEnd;
};

const isCommand=function(arg){
return(0,_semver.validRange)(arg)===null;
};
//# sourceMappingURL=parse.js.map