"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.runSerial=void 0;var _execa=_interopRequireDefault(require("execa"));
var _nvexeca=_interopRequireDefault(require("nvexeca"));

var _stdin=require("./stdin.js");
var _header=require("./header.js");
var _dry=require("./dry.js");
var _error=require("./error.js");function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}


const runSerial=async function({
versionRanges,
command,
args,
opts,
continueOpt})
{
if(command===undefined){
return(0,_dry.printVersions)(versionRanges,opts);
}

const stdinOptions=await(0,_stdin.getSerialStdinOptions)();
const optsA={
...opts,
dry:true,
...stdinOptions,
stdout:"inherit",
stderr:"inherit",
reject:true,
buffer:false};


const versions=await Promise.all(
versionRanges.map((versionRange)=>
(0,_nvexeca.default)(versionRange,command,args,optsA)));



const state={};
await runProcesses({versions,state,continueOpt});
return state.exitCode;
};exports.runSerial=runSerial;

const runProcesses=async function({versions,state,continueOpt}){

for(const{versionRange,command,args,execaOptions}of versions){
(0,_header.printVersionHeader)(versionRange);


const shouldStop=await runProcess({
versionRange,
command,
args,
execaOptions,
state,
continueOpt});






if(shouldStop){
return;
}
}
};

const runProcess=async function({
versionRange,
command,
args,
execaOptions,
state,
continueOpt})
{
try{
await(0,_execa.default)(command,args,execaOptions);
}catch(error){
(0,_error.handleSerialError)(error,versionRange,state);
return!continueOpt;
}
};
//# sourceMappingURL=serial.js.map